﻿Public Class Form1
    'Klassenobject erzeugen.
    Private WithEvents _wP As New WebsitePicture()

    'Zum Prüfen, ob schon fertig geladen ist. Wegen den NumericUpDowns.
    Private _loadingFlag As Boolean = True

    Private Sub btnGetImage_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnGetImage.Click
        'Wartebild anzeigen.
        Me.pBxPicture.Image = My.Resources.warten

        Me.Text = "WebsitePicture - working"

        'uriString festlegen.
        _wP.uriString = txtAdress.Text

        'Fullimage anfordern.
        _wP.GetFullImage()
    End Sub

    Private Sub btnSave_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSave.Click
        'Angezeigtes Bild speichern.
        If sFD.ShowDialog = Windows.Forms.DialogResult.OK Then
            Me.pBxPicture.Image.Save(sFD.FileName)

            Me.lLlPath.Text = sFD.FileName
            Me.lLlPath.Visible = True
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        txtAdress.Text = "http://www.activevb.de"

        Me.nUDWidth.Value = _wP.imageSize.Width
        Me.nUDHeight.Value = _wP.imageSize.Height

        _loadingFlag = False
    End Sub

    Private Sub lLlPath_LinkClicked(ByVal sender As Object, ByVal e As LinkLabelLinkClickedEventArgs) Handles lLlPath.LinkClicked
        'Pfad zu Bild öffnen.
        If System.IO.File.Exists(Me.lLlPath.Text) Then
            Process.Start(Me.lLlPath.Text)
        Else
            MessageBox.Show("Die gewünschte Datei ist nicht vorhanden!", "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    Private Sub nUDWidth_ValueChanged(ByVal sender As Object, ByVal e As EventArgs) Handles nUDWidth.ValueChanged, nUDHeight.ValueChanged
        If Not _loadingFlag Then
            _wP.imageSize = New Size(CInt(Me.nUDWidth.Value), CInt(Me.nUDHeight.Value))
        End If
    End Sub

    ''' <summary>
    ''' Event abfangen.
    ''' </summary>
    Private Sub _wP_ImageReady(ByVal sender As Object, ByVal e As WebsitePictureEventArgs) Handles _wP.ImageReady
        Me.pBxPicture.Image = e.Bmp

        Me.Text = "WebsitePicture - ready"

        Me.Label2.Text = "Dauer: " & e.Duration.TotalSeconds.ToString().Substring(0, 4) & " s"

        Me.btnSave.Enabled = True
    End Sub

    ''' <summary>
    ''' Abfangen, wenn sich der Ladestatus ändert.
    ''' </summary>
    Private Sub _wP_ProgressChanged(ByVal sender As Object, ByVal e As WebsitePicutureProgressEventArgs) Handles _wP.ProgressChanged
        Me.Label2.Text = "Dauer: " & e.Elapsed.TotalSeconds.ToString().Substring(0, 4) & " s"
    End Sub

    ''' <summary>
    ''' Auf Entertaste reagieren.
    ''' </summary>
    Private Sub txtAdress_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtAdress.KeyDown
        If e.KeyCode = Keys.Enter Then
            btnGetImage.PerformClick()
        End If
    End Sub
End Class